#include <stdio.h>
#include <stdlib.h>


#define _REENTRANT
#include<pthread.h>

void *sub(void *);

typedef struct
{
	int *arr;
	int start;
	int stop;
	int result;
} threaddata;



int *readintegers(char *filename, int *arr, int *length, int *numread)
{
	int res,i;
	FILE *f;
	
	*numread = 0;
	f = fopen(filename, "r");
	while ((res=fscanf(f,"%i\n", &i)) != EOF) {
		if (*numread >= *length) {
			arr = (int *) realloc (arr, sizeof(int)*(*length+100));
			*length += 100;
		}
		arr[(*numread)++] = i;
	}
	fclose(f);
/*        for ( i=0; i < *numread; i++) {
               printf("%i ",arr[i]);
        }*/
		
	return arr;
}

int main(int argc, char *argv[])
{
	char *filename;
	int numproc;
	
	int length, numread;
	int *arr;

	int i;
	pthread_t *threads;
	threaddata *data;
	int result=0;
	
	if (argc != 3) {
		printf("Usage: prog filename numproc\n");
		return 1;
	}

	filename = argv[1];
	numproc = atoi(argv[2]);
	arr = malloc(sizeof(int)*10);
	length = 10;
	arr = readintegers(filename, arr, &length, &numread);
	
/*	printf("\n%s %i\n",filename,numproc);
	for ( i=0; i < numread; i++) {
		printf("%i ",arr[i]);
		}	*/
	

	threads = (pthread_t *)malloc(numproc*sizeof(pthread_t));
	data = (threaddata *)malloc(numproc*sizeof(threaddata));

	printf("This is main thread\n");

	for (i=0;i<numproc;i++) {
		data[i].arr = arr;
		data[i].result = 0;
		data[i].start = numread/numproc*i;
		data[i].stop = numread/numproc*(i+1);
		if (i == numproc - 1 )
			data[i].stop += numread % numproc;

		if (pthread_create(&threads[i], NULL, sub, &data[i] ))
		         fprintf(stderr, "Can't create thread\n"), exit(1);
		}

	printf("Main thread still\n");

	for (i=0;i<numproc;i++) {
		if (pthread_join(threads[i], NULL)!=0) {perror("Join error\n"); exit(-1);}
        }

	for (i=0;i<numproc;i++) {
		result += data[i].result;
	}
	printf("Result is %i\n",result);
}

void * sub(void *arg)
{
	threaddata *data = (threaddata *) arg;
	int me;
	int i;

	me = pthread_self();

	printf("This is thread %i\n", me);

	for (i=data->start; i < data->stop; i++)
		data->result += data->arr[i];
	
	return NULL;
}

