#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"



int main(int argc, char *argv[])
{
	int ptid,tid;
	int size,tidsize;
	int *arr1,*arr2, *tids;
	int i, result=0;
	int res;
	int id;
	FILE *f;	
	char *filename;
	
	ptid = pvm_parent();
	tid = pvm_mytid();
	pvm_recv(ptid, -1);
	
	pvm_upkint(&size,1,1);
	arr1 = malloc(sizeof(int)*size);
	arr2 = malloc(sizeof(int)*size);
	pvm_upkint(arr1,size,1);
	pvm_upkint(arr2,size,1);
	
	pvm_upkint(&tidsize,1,1);
	tids = malloc(sizeof(int)*tidsize);
	pvm_upkint(tids,tidsize,1);
		
	for (i=0;i<size;i++) {
		result+=arr1[i]*arr2[i];
	}

	pvm_initsend(PvmDataDefault);

	for (i = 0; i < tidsize; i++)
		if (tids[i] == tid) {
			id = i;
			break;
		}
	
	asprintf (&filename, "pa2/debug%i.log", id);	
	f = fopen(filename, "w");
	fprintf(f,"task %i got result %i\n",id,result);	
	fflush(f);

	for (i = 1; i < tidsize; i=i*2) {
		fprintf(f,"step %i\n",i);
		if(((id -i) % (i*2)) ==0) {
			fprintf(f,"step %i,sending result to task %i\n",i,id-i);
			fflush(f);
			pvm_pkint (&result,1,1);
			pvm_send(tids[id-i],1);
				}
		if (((id % (i*2)) == 0) && ((id+i) < tidsize)) {
			fprintf(f,"step %i, receiving result from task %i\n",i,id+i);
			fflush(f);
			pvm_recv(tids[id + i],-1);
			pvm_upkint(&res,1,1);
			fprintf(f,"step %i, received result %i from task %i\n",i,res,id+i);
			fflush(f);
			result +=res;
		}
	}
	fprintf(f,"quitting\n");
	
	if (id == 0) {
		pvm_pkint(&result,1,1);
		pvm_send(ptid, 1);
	}

	pvm_exit();

	exit(0);
}
