#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"


int *readintegers(char *filename, int *arr, int *length, int *numread)
{
	int res,i;
	FILE *f;
	
	*numread = 0;
	f = fopen(filename, "r");
	while ((res=fscanf(f,"%i\n", &i)) != EOF) {
		if (*numread >= *length) {
			arr = (int *) realloc (arr, sizeof(int)*(*length+100));
			*length += 100;
		}
		arr[(*numread)++] = i;
	}
	fclose(f);
/*        for ( i=0; i < *numread; i++) {
               printf("%i ",arr[i]);
        }*/
		
	return arr;
}

int main(int argc, char *argv[])
{
	char *filename;
	int numproc;
	
	int length, numread;
	int *arr;
	int *tids;

	int i,cc,start,sublength;
	int result=0, res;
	
	if (argc != 3) {
		printf("Usage: prog filename numproc\n");
		return 1;
	}

	filename = argv[1];
	numproc = atoi(argv[2]);
	arr = malloc(sizeof(int)*10);
	length = 10;
	arr = readintegers(filename, arr, &length, &numread);
	
/*	printf("\n%s %i\n",filename,numproc);
	for ( i=0; i < numread; i++) {
		printf("%i ",arr[i]);
		}	*/
	

	tids = malloc(sizeof(int)*numproc);
	cc = pvm_spawn("exc1/pvm_calc", (char**)0, 0, "", numproc, tids);
	printf("%i\n",cc);
	if (cc == numproc) {
		for (i=0; i < numproc;i++) {
			pvm_initsend(PvmDataDefault);
			start = numread/numproc*i;
			sublength = numread/numproc;
			if (i == numproc - 1 )
				sublength += numread % numproc;
			printf("%i %i\n",start,sublength);
			pvm_pkint(&sublength,1,1);
			pvm_pkint(&arr[start],sublength,1);
			pvm_send(tids[i],1);
		}

		for (i=0; i < numproc;i++) {
			pvm_recv(-1,-1);
			pvm_upkint(&res,1,1);
			printf("subResult[%i]=%i\n",i,res);
			result+= res;
		}
		printf("Result is %i\n",result);
		
	}  else printf("can't start pvm_calc\n");

	pvm_exit();

	exit(0);
/*	
	for (i=0;i<numproc;i++) {
		
		data[i].arr = arr;
		data[i].result = 0;
		data[i].start = length/numproc*i;
		data[i].stop = length/numproc*(i+1);
		if (i == numproc - 1 )
			data[i].stop += length % numproc;

		if (pthread_create(&threads[i], NULL, sub, &data[i] ))
		         fprintf(stderr, "Can't create thread\n"), exit(1);
		}

	printf("Main thread still\n");

	for (i=0;i<numproc;i++) {
		if (pthread_join(threads[i], NULL)!=0) {perror("Join error\n"); exit(-1);}
        }

	for (i=0;i<numproc;i++) {
		result += data[i].result;
	}
	printf("Result is %i\n",result); */
}
